// Common.cpp : implementation file
//

#include "stdafx.h"
#include "Common.h"

CString DateTimeToString(DATE tsDateTime, 
                         bool withDate/* =true*/,
                         bool withTime/* =true*/, 
                         bool withSeconds/* =false */)
{
   SYSTEMTIME stDateTime;
   VariantTimeToSystemTime(tsDateTime, &stDateTime);

   CString timeString;
   CString dateTimeString;
   if (withDate)
   {
      dateTimeString.Format(_T("%.2d/%.2d/%.2d"),
                            stDateTime.wMonth, 
                            stDateTime.wDay,
                            stDateTime.wYear);
   }

   if (withTime)
   {
      timeString.Format(_T("%.2d:%.2d"),
                        stDateTime.wHour,
                        stDateTime.wMinute);
      dateTimeString += withDate ? _T(" ") : _T("");
      dateTimeString += timeString;
   }

   if (withSeconds)
   {
      timeString.Format(_T(":%.2d"),
                        stDateTime.wSecond);
      dateTimeString += timeString;
   }

   return dateTimeString;
}

CString VariantToString(const ATL::CComVariant& value)
{
   CString strValue;
   switch (value.vt)
   {
      case VT_I4:
         strValue.Format(_T("%d"), value.intVal);
         break;
      case VT_UI4:
         strValue.Format(_T("%d"), value.uintVal);
         break;
      case VT_R8:
         strValue.Format(_T("%f"), value.dblVal);
         break;
      case VT_DATE:
         strValue = DateTimeToString(value.date);
         break;
      case VT_BSTR:
         strValue = ATL::CW2T(value.bstrVal);
         break;
      case VT_BOOL:
         strValue = (value.boolVal == VARIANT_TRUE) ? _T("True") : _T("False");
         break;
      default:
         throw std::runtime_error(std::string("Unknown type"));
   }

   return strValue;
}