// SymbolResolutionDlg.cpp : implementation file
//

#include "stdafx.h"
#include <sstream>
#include "Common.h"
#include "TradableInstruments.h"
#include "TradableInstrumentsDlg.h"

CTradableInstrumentsDlg::CTradableInstrumentsDlg(
                                 CWnd* pParent /*=NULL*/)
   : CDialog(CTradableInstrumentsDlg::IDD, pParent)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//////////////////////////////////////////////////////////////////////////
//////////////////// Overridden methods and message handlers
//////////////////////////////////////////////////////////////////////////
void CTradableInstrumentsDlg::DoDataExchange(
                                 CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_BTNGETCOMMODITIES, m_btnGetCommodities);
   DDX_Control(pDX, IDC_BTNGETFULLNAMES, m_btnGetFullnames);
   DDX_Control(pDX, IDC_BTNREMOVE, m_btnRemove);
   DDX_Control(pDX, IDC_BTNREMOVEALL, m_btnRemoveAll);
   DDX_Control(pDX, IDC_CHKFUTURES, m_cbFutures);
   DDX_Control(pDX, IDC_CHKPUTOPTIONS, m_cbPutOptions);
   DDX_Control(pDX, IDC_CHKCALLOPTIONS, m_cbCallOptions);
   DDX_Control(pDX, IDC_CHKTREASURIES, m_cbTreasuries);
   DDX_Control(pDX, IDC_CHKOTHER, m_cbOther);
   DDX_Control(pDX, IDC_EDSYMBOL, m_edSymbol);
   DDX_Control(pDX, IDC_STDATACONNECTION, m_lblDataConnection);
   DDX_Control(pDX, IDC_STGWCONNECTION, m_lblGWConnection);
   DDX_Control(pDX, IDC_STLINETIME, m_lblLineTime);
   DDX_Control(pDX, IDC_LSVACCOUNTS, m_lvAccounts);
   DDX_Control(pDX, IDC_TRCOMMODITIES, m_trCommodities);
   DDX_Control(pDX, IDC_TRFULLNAMES, m_trFullNames);
   DDX_Control(pDX, IDC_TREXCHANGES, m_trExchanges);
   DDX_Control(pDX, IDC_BTNGETEXCHANGES, m_btnGetExchanges);
}

BEGIN_MESSAGE_MAP(CTradableInstrumentsDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTNGETCOMMODITIES, OnBnClickedBtnGetCommodities)
   ON_BN_CLICKED(IDC_BTNGETFULLNAMES, OnBnClickedBtnGetFullnames)
   ON_BN_CLICKED(IDC_BTNREMOVE, OnBnClickedBtnRemove)
   ON_BN_CLICKED(IDC_BTNREMOVEALL, OnBnClickedBtnRemoveAll)
   ON_BN_CLICKED(IDC_BTNSELECTALLDSS, OnBnClickedBtnSelectAllDSs)
   ON_BN_CLICKED(IDC_BTNUNSELECTALLDSS, OnBnClickedBtnUnselectAllDSs)
   ON_EN_CHANGE(IDC_EDSYMBOL, OnEnChangeEdSymbol)
   ON_NOTIFY(LVN_ITEMCHANGED, IDC_LSVACCOUNTS, OnLvnItemChangedLsvAccounts)
   ON_NOTIFY(TVN_SELCHANGED, IDC_TRCOMMODITIES, OnTvnSelChangedTrCommodities)
   ON_NOTIFY(TVN_SELCHANGED, IDC_TRFULLNAMES, OnTvnSelChangedTrFullNames)
   ON_BN_CLICKED(IDC_BTNGETEXCHANGES, OnBnClickedBtnGetexchanges)
END_MESSAGE_MAP()

BOOL CTradableInstrumentsDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon

   InitializeControls();

   InitializeCQGCEL();

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTradableInstrumentsDlg::OnDestroy()
{
   try
   {
      ShutdownCQGCEL();

      CDialog::OnDestroy();
   }
   catch (std::runtime_error& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradableInstrumentsDlg::OnOK()
{
   // Override to prevent dialog closing on Enter
}

void CTradableInstrumentsDlg::OnCancel()
{
   // Add Override code here

   CDialog::OnCancel();
}

// If you add a minimize button to your dialog, you will need the code below
// to draw the icon.  For MFC applications using the document/view model,
// this is automatically done for you by the framework.
void CTradableInstrumentsDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

BOOL CTradableInstrumentsDlg::PreTranslateMessage(MSG* pMsg)
{
   if ( pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_RETURN )
   {
      int idCtrl= this->GetFocus()->GetDlgCtrlID();
      if (idCtrl == IDC_EDSYMBOL) OnBnClickedBtnGetFullnames();
   }
   return CDialog::PreTranslateMessage( pMsg );
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTradableInstrumentsDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

//////////////////////////////////////////////////////////////////////////
//////////////////// Dialog controls events handlers
//////////////////////////////////////////////////////////////////////////
void CTradableInstrumentsDlg::OnBnClickedBtnGetCommodities()
{
   try
   {
      HRESULT hr;

      m_trCommodities.DeleteAllItems();

      if (GetCheckedAccountsCount() == m_lvAccounts.GetItemCount())
      {
         // To get all accounts commodities request with argument 0
         hr = m_spCQGCEL->RequestTradableCommodities(0);
          Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
      else
      {
         // Iterate over checked accounts and request for each separately
         for (int i = 0; i < m_lvAccounts.GetItemCount(); ++i)
         {
            if (m_lvAccounts.GetCheck(i))
            {
               int GWAccID = _ttoi(m_lvAccounts.GetItemText(i,2).GetString());
               hr = m_spCQGCEL->RequestTradableCommodities(GWAccID);
                Common::ThrowOnCOMError(m_spCQGCEL, hr);
            }
         }
      }
   }
   catch (std::runtime_error& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradableInstrumentsDlg::OnBnClickedBtnGetFullnames()
{
   try
   {
      CString symbol;
      long instrumentTypes;

      // To request for only tradable instruments
      // Gateway server connection must be up
      m_edSymbol.GetWindowText(symbol);
      GetTypes(instrumentTypes);
      HRESULT hr = m_spCQGCEL->RequestCommodityInstruments(
                                       ATL::CT2W(symbol), 
                                       (eInstrumentType)instrumentTypes, true);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);
   }
   catch (std::runtime_error& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradableInstrumentsDlg::OnBnClickedBtnRemove()
{
   HTREEITEM hTrItem = m_trFullNames.GetSelectedItem();

   // Only root nodes can be removed
   ATLASSERT(m_trFullNames.GetParentItem(hTrItem) == NULL);

   m_trFullNames.DeleteItem(hTrItem);
   m_trFullNames.SetFocus();

   EnableControls();
}

void CTradableInstrumentsDlg::OnBnClickedBtnRemoveAll()
{
   m_trFullNames.DeleteAllItems();

   m_btnRemove.EnableWindow(FALSE);
   m_btnRemoveAll.EnableWindow(FALSE);
}

void CTradableInstrumentsDlg::OnBnClickedBtnSelectAllDSs()
{
   CheckAllAccounts(true);
}

void CTradableInstrumentsDlg::OnBnClickedBtnUnselectAllDSs()
{
   CheckAllAccounts(false);
}

void CTradableInstrumentsDlg::OnEnChangeEdSymbol()
{
   m_btnGetFullnames.EnableWindow((m_edSymbol.GetWindowTextLength() != 0) &&
                                    IsDataConnectionUp());
}

void CTradableInstrumentsDlg::OnLvnItemChangedLsvAccounts(
                                 NMHDR * /*pNMHDR*/,
                                 LRESULT *pResult)
{
   EnableControls();

   *pResult = 0;
}

void CTradableInstrumentsDlg::OnTvnSelChangedTrCommodities(
                                 NMHDR *pNMHDR,
                                 LRESULT *pResult)
{
   LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

   // Fill selected commodity to the commodity edit box
   HTREEITEM hTrItem = pNMTreeView->itemNew.hItem;
   if (m_trCommodities.GetParentItem(hTrItem) != NULL)
   {
      CString symbol = m_trCommodities.GetItemText(hTrItem);
      m_edSymbol.SetWindowText(symbol);
   }

   *pResult = 0;
}

void CTradableInstrumentsDlg::OnTvnSelChangedTrFullNames(
                                 NMHDR * /*pNMHDR*/, 
                                 LRESULT *pResult)
{
   EnableControls();

   *pResult = 0;
}

void CTradableInstrumentsDlg::OnBnClickedBtnGetexchanges()
{
   try
   {
      HRESULT hr;

      m_trExchanges.DeleteAllItems();

      if (GetCheckedAccountsCount() == m_lvAccounts.GetItemCount())
      {
         // To get all accounts exchanges request with argument 0
         hr = m_spCQGCEL->RequestTradableExchanges(0);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
      else
      {
         // Iterate over checked accounts and request for each separately
         int GWAccID;
         for (int i = 0; i < m_lvAccounts.GetItemCount(); ++i)
         {
            if (m_lvAccounts.GetCheck(i))
            {
               std::stringstream strm;
               strm << m_lvAccounts.GetItemText(i,2).GetString();
               strm >> GWAccID;
               hr = m_spCQGCEL->RequestTradableExchanges(GWAccID);
               Common::ThrowOnCOMError(m_spCQGCEL, hr);
            }
         }
      }
   }
   catch (std::runtime_error& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}